import time, os, sys, json, requests
import xbmc, xbmcplugin, xbmcaddon
from sqlite3 import dbapi2 as database

ADDON_ID='script.coinmarket'
addon=xbmcaddon.Addon(id=ADDON_ID)
home=xbmc.translatePath(addon.getAddonInfo('path').decode('utf-8'))

profileDir = addon.getAddonInfo('profile')
profileDir = xbmc.translatePath(profileDir).decode("utf-8")

names = ['0x (ZRX)', '0xBitcoin (0xBTC)', '1World (1WO)', '2GIVE (2GIVE)', '300 Token (300)', '42-coin (42)', '808Coin (808)', '8Bit (8BIT)', 'AC3 (AC3)', 'ACChain (ACC)', 'AI Doctor (AIDOC)', 'AICHAIN (AIT)', 'ALIS (ALIS)', 'ALQO (ALQO)', 'AMLT (AMLT)', 'APIS (APIS)', 'APR Coin (APR)', 'APX (APX)', 'ARbit (ARB)', 'ATBCoin (ATB)', 'ATLANT (ATL)', 'ATMChain (ATM)', 'ATMCoin (ATMC)', 'ATN (ATN)', 'AWARE (AWR)', 'Abjcoin (ABJ)', 'Accelerator Network (ACC)', 'Ace (ACE)', 'Aces (ACES)', 'Achain (ACT)', 'Acoin (ACOIN)', 'Acute Angle Cloud (AAC)', 'AdCoin (ACC)', 'AdEx (ADX)', 'AdHive (ADH)', 'AdShares (ADST)', 'Aditus (ADI)', 'Advanced Internet Blocks (AIB)', 'Advanced Technology Coin (ARC)', 'Adzcoin (ADZ)', 'Aeon (AEON)', 'Aerium (AERM)', 'Aeron (ARN)', 'Aeternity (AE)', 'Agrello (DLT)', 'AidCoin (AID)', 'Aidos Kuneen (ADK)', 'Aigang (AIX)', 'Aion (AION)', 'AirSwap (AST)', 'AirToken (AIR)', 'Akuya Coin (AKY)', 'All Sports (SOC)', 'AllSafe (ASAFE2)', 'Allion (ALL)', 'Alphabit (ABC)', 'Alphacat (ACAT)', 'Altcoin (ALT)', 'Ambrosus (AMB)', 'Ammo Reloaded (AMMO)', 'Amon (AMN)', 'AmsterdamCoin (AMS)', 'AnarchistsPrime (ACP)', 'Animation Vision Cash (AVH)', 'Animecoin (ANI)', 'Anoncoin (ANC)', 'Antimatter (ANTX)', 'Apex (CPX)', 'Aphelion (APH)', 'AppCoins (APPC)', 'AquariusCoin (ARCO)', 'Aragon (ANT)', 'Arbitracoin (ATC)', 'ArbitrageCT (ARCT)', 'Arcblock (ABT)', 'Ardor (ARDR)', 'Argentum (ARG)', 'Argus (ARGUS)', 'Aricoin (ARI)', 'Ark (ARK)', 'ArtByte (ABY)', 'Artex Coin (ATX)', 'Asch (XAS)', 'Aseancoin (ASN)', 'AsiaCoin (AC)', 'Asiadigicoin (ADCN)', 'Aston (ATX)', 'Astro (ASTRO)', 'Atmos (ATMOS)', 'Atomic Coin (ATOM)', 'Auctus (AUC)', 'AudioCoin (ADC)', 'Augur (REP)', 'Aurora DAO (AURA)', 'Auroracoin (AUR)', 'AurumCoin (AU)', 'Authorship (ATS)', 'Autonio (NIO)', 'AvatarCoin (AV)', 'Aventus (AVT)', 'Avoncoin (ACN)', 'Axiom (AXIOM)', 'B2BX (B2B)', 'B3Coin (KB3)', 'BABB (BAX)', 'BERNcash (BERN)', 'BLOCKv (VEE)', 'BOAT (BOAT)', 'BOScoin (BOS)', 'BROTHER (BRAT)', 'BT2 [CST] (BT2)', 'BTCMoon (BTCM)', 'BTCtalkcoin (TALK)', 'Banca (BANCA)', 'Bancor (BNT)', 'Bank Coin (BANK)', 'Bankcoin (B@)', 'Bankera (BNK)', 'Bankex (BKX)', 'Banyan Network (BBN)', 'Basic Attention Token (BAT)', 'Bastonet (BSN)', 'Bata (BTA)', 'Bean Cash (BITB)', 'Beatcoin (XBTS)', 'Bee Token (BEE)', 'Bela (BELA)', 'BelugaPay (BBI)', 'BenjiRolls (BENJI)', 'BestChain (BEST)', 'BetaCoin (BET)', 'BetterBetting (BETR)', 'Bezant (BZNT)', 'Bezop (BEZ)', 'BiblePay (BBP)', 'Bibox Token (BIX)', 'BigONE Token (BIG)', 'BigUp (BIGUP)', 'Bigbom (BBO)', 'Billionaire Token (XBL)', 'Binance Coin (BNB)', 'BioBar (BIOB)', 'BioCoin (BIO)', 'Biotron (BTRN)', 'BipCoin (BIP)', 'Birds (BIRDS)', 'Bismuth (BIS)', 'Bit20 (BTWTY)', 'BitAsean (BAS)', 'BitBar (BTB)', 'BitBay (BAY)', 'BitClave (CAT)', 'BitCoal (COAL)', 'BitConnect (BCC)', 'BitDegree (BDG)', 'BitDice (CSNO)', 'BitQuark (BTQ)', 'BitRent (RNTB)', 'BitSend (BSD)', 'BitSerial (BTE)', 'BitShares (BTS)', 'BitSoar (BSR)', 'BitStation (BSTN)', 'BitTokens (BXT)', 'BitTube (TUBE)', 'BitWhite (BTW)', 'Bitair (BTCA)', 'Bitbase (BTBc)', 'Bitcloud (BTDX)', 'Bitcoin (BTC)', 'Bitcoin 21 (XBTC21)', 'Bitcoin Atom (BCA)', 'Bitcoin Cash (BCH)', 'Bitcoin Diamond (BCD)', 'Bitcoin Fast (BCF)', 'Bitcoin God (GOD)', 'Bitcoin Gold (BTG)', 'Bitcoin Green (BITG)', 'Bitcoin Interest (BCI)', 'Bitcoin Planet (BTPL)', 'Bitcoin Plus (XBC)', 'Bitcoin Private (BTCP)', 'Bitcoin Red (BTCRED)', 'Bitcoin Scrypt (BTCS)', 'BitcoinDark (BTCD)', 'BitcoinX (BCX)', 'BitcoinZ (BTCZ)', 'Bitcore (BTX)', 'Bitcrystals (BCY)', 'Bitcurrency (BTCR)', 'Bitdeal (BDL)', 'Bitgem (BTG)', 'Bitmark (BTM)', 'Bitok (BITOK)', 'Bitradio (BRO)', 'Bitstar (BITS)', 'Bitsum (BSM)', 'Bitswift (SWIFT)', 'Bitvolt (VOLT)', 'Bitz (BITZ)', 'Bitzeny (ZNY)', 'BlackCoin (BLK)', 'Blackmoon (BMC)', 'Blakecoin (BLC)', 'BlazeCoin (BLZ)', 'BlazerCoin (BLAZR)', 'BlitzPredict (XBP)', 'Block Array (ARY)', 'BlockCAT (CAT)', 'BlockCDN (BCDN)', 'BlockMason Credit Protocol (BCPT)', 'BlockMesh (BMH)', 'BlockPay (BLOCKPAY)', 'Blocklancer (LNC)', 'Blocknet (BLOCK)', 'Blockpool (BPL)', 'Blockport (BPT)', 'Blocktix (TIX)', 'Bloom (BLT)', 'Blox (CDT)', 'Blue Protocol (BLUE)', 'BlueCoin (BLU)', 'Bluzelle (BLZ)', 'BnkToTheFuture (BFT)', 'BnrtxCoin (BNX)', 'Bodhi (BOT)', 'Bolenum (BLN)', 'Bolivarcoin (BOLI)', 'Bonpay (BON)', 'Boolberry (BBR)', 'BoostCoin (BOST)', 'Bottos (BTO)', 'Bounty0x (BNTY)', 'BoutsPro (BOUTS)', 'Bowhead (AHT)', 'BowsCoin (BSC)', 'BrahmaOS (BRM)', 'Bread (BRD)', 'Breakout (BRK)', 'Breakout Stake (BRX)', 'BriaCoin (BRIA)', 'BridgeCoin (BCO)', 'BritCoin (BRIT)', 'Bubble (BUB)', 'Budbo (BUBO)', 'Bullion (CBX)', 'Bulwark (BWK)', 'BumbaCoin (BUMBA)', 'BunnyCoin (BUN)', 'Burst (BURST)', 'BuzzCoin (BUZZ)', 'Byteball Bytes (GBYTE)', 'Bytecent (BYC)', 'Bytecoin (BCN)', 'Bytom (BTM)', 'C-Bit (XCT)', 'CEEK VR (CEEK)', 'CFun (CFUN)', 'CGC Token (CGC)', 'CHIPS (CHIPS)', 'CK USD (CKUSD)', 'COMSA [ETH] (CMS)', 'COMSA [XEM] (CMS)', 'COPYTRACK (CPY)', 'CORION (COR)', 'COSS (COSS)', 'CPChain (CPC)', 'CRYPTO20 (C20)', 'CVCoin (CVCOIN)', 'Cabbage (CAB)', 'CacheCoin (CACH)', 'Californium (CF)', 'Callisto Network (CLO)', 'CampusCoin (CMPCO)', 'CanYaCoin (CAN)', 'Canada eCoin (CDN)', 'Candy (CANDY)', 'CannaCoin (CCN)', 'CannabisCoin (CANN)', 'Cannation (CNNC)', 'Cappasity (CAPP)', 'Capricoin (CPC)', 'CarTaxi Token (CTX)', 'Carboncoin (CARBON)', 'Cardano (ADA)', 'CargoX (CXO)', 'CashBet Coin (CBC)', 'Cashaa (CAS)', 'Cashcoin (CASH)', 'CasinoCoin (CSC)', 'Catcoin (CAT)', 'Cazcoin (CAZ)', 'Ccore (CCO)', 'Centrality (CENNZ)', 'Centurion (CNT)', 'ChainCoin (CHC)', 'ChainLink (LINK)', 'Chainium (CHX)', 'ChanCoin (CHAN)', 'Change (CAG)', 'ChatCoin (CHAT)', 'Cheapcoin (CHEAP)', 'ChessCoin (CHESS)', 'Chronobank (TIME)', 'Chronologic (DAY)', 'Cindicator (CND)', 'Circuits of Value (COVAL)', 'Civic (CVC)', 'Clams (CLAM)', 'ClearCoin (CLR)', 'ClearPoll (POLL)', 'CloakCoin (CLOAK)', 'Cloud (CLD)', 'ClubCoin (CLUB)', 'Cobinhood (COB)', 'CoffeeCoin (CFC)', 'Cofound.it (CFI)', 'Coimatic 2.0 (CTIC2)', 'Coimatic 3.0 (CTIC3)', 'Coin(O) (CNO)', 'Coin2.1 (C2)', 'CoinFi (COFI)', 'CoinMeet (MEET)', 'CoinPoker (CHP)', 'Coinlancer (CL)', 'Coinonat (CXT)', 'CoinonatX (XCXT)', 'ColossusXT (COLX)', 'Colu Local Network (CLN)', 'Comet (CMT)', 'CommerceBlock (CBT)', 'Commodity Ad Network (CDX)', 'CompuCoin (CPN)', 'Concoin (CONX)', 'Condensate (RAIN)', 'ConnectJob (CJT)', 'Consensus (SEN)', 'Content Neutrality Network (CNN)', 'Content and AD Network (CAN)', 'ContractNet (CNET)', 'Cortex (CTXC)', 'Couchain (COU)', 'Counterparty (XCP)', 'Coupecoin (COUPE)', 'Covesting (COV)', 'Crave (CRAVE)', 'Cream (CRM)', 'Creatio (XCRE)', 'Creativecoin (CREA)', 'Credence Coin (CRDNC)', 'Creditbit (CRB)', 'Credits (CS)', 'Credo (CREDO)', 'CrevaCoin (CREVA)', 'Cropcoin (CROP)', 'Crowd Machine (CMCT)', 'CrowdCoin (CRC)', 'Crown (CRW)', 'CryCash (CRC)', 'CryptCoin (CRYPT)', 'Cryptaur (CPT)', 'Crypterium (CRPT)', 'Crypto (CTO)', 'CryptoCarbon (CCRB)', 'CryptoInsight (TKR)', 'CryptoPing (PING)', 'CryptoWorldX Token (CWXT)', 'Cryptojacks (CJ)', 'Cryptonex (CNX)', 'Cryptonite (XCN)', 'Cryptopay (CPAY)', 'CryptopiaFeeShares (CEFS)', 'Crystal Clear  (CCT)', 'Cube (AUTO)', 'Cubits (QBT)', 'Curecoin (CURE)', 'Curriculum Vitae (CVH)', 'CyberMiles (CMT)', 'CyberVein (CVT)', 'Cybereits (CRE)', 'Cycling Coin (CYC)', 'Cyder (CYDER)', 'DADI (DADI)', 'DAEX (DAX)', 'DAO.Casino (BET)', 'DAOstack (GEN)', 'DAPPSTER (DLISK)', 'DATA (DTA)', 'DATx (DATX)', 'DCORP Utility (DRPU)', 'DECENT (DCT)', 'DEW (DEW)', 'DIMCOIN (DIM)', 'DMarket (DMT)', 'DROXNE (DRXNE)', 'Dai (DAI)', 'Dalecoin (DALC)', 'Daneel (DAN)', 'Darcrus (DAR)', 'Darsek (KED)', 'Dascoin (DASC)', 'Dash (DASH)', 'Dashcoin (DSH)', 'Databits (DTB)', 'Datacoin (DTC)', 'Datarius Credit (DTRC)', 'Datawallet (DXT)', 'Datum (DAT)', 'DaxxCoin (DAXX)', 'Debitcoin (DBTC)', 'Debitum (DEB)', 'DecentBet (DBET)', 'Decentraland (MANA)', 'Decentralized Machine Learning (DML)', 'Decision Token (HST)', 'Decred (DCR)', 'DeepBrain Chain (DBC)', 'DeepOnion (ONION)', 'Delphy (DPY)', 'Denarius (DNR)', 'Dent (DENT)', 'Dentacoin (DCN)', 'Dero (DERO)', 'Desire (DSR)', 'Destiny (DES)', 'Dether (DTH)', 'DeusCoin (DEUS)', 'Deutsche eMark (DEM)', 'Devery (EVE)', 'DeviantCoin (DEV)', 'Diamond (DMD)', 'DigiByte (DGB)', 'DigiCube (CUBE)', 'DigiPulse (DGPT)', 'Digital Money Bits (DMB)', 'Digital Rupees (DRS)', 'DigitalDevelopersFund (DDF)', 'DigitalNote (XDN)', 'DigitalPrice (DP)', 'Digitalcoin (DGC)', 'Digitex Futures (DGTX)', 'Digix Gold Token (DGX)', 'DigixDAO (DGD)', 'Dignity (DIG)', 'Dimecoin (DIME)', 'Dinastycoin (DCY)', 'Divi (DIVX)', 'Dix Asset (DIX)', 'Docademic (MTC)', 'Dock (DOCK)', 'Dogecoin (DOGE)', 'Dollar Online (DOLLAR)', 'Dollarcoin (DLC)', 'DomRaider (DRT)', 'Donationcoin (DON)', 'DopeCoin (DOPE)', 'Dotcoin (DOT)', 'Dovu (DOVU)', 'DraftCoin (DFT)', 'Dragon Coins (DRG)', 'Dragonchain (DRGN)', 'Dreamcoin (DRM)', 'Dropil (DROP)', 'DubaiCoin (DBIX)', 'Dutch Coin (DUTCH)', 'Dynamic (DYN)', 'Dynamic Trading Rights (DTR)', 'DynamicCoin (DMC)', 'E-Dinar Coin (EDR)', 'E-coin (ECN)', 'EA Coin (EAG)', 'EBCH (EBCH)', 'ECC (ECC)', 'EDRCoin (EDRC)', 'EDUCare (EKT)', 'EJOY (EJOY)', 'ELTCOIN (ELTCOIN)', 'ENTCash (ENT)', 'EOS (EOS)', 'ERA (ERA)', 'ERC20 (ERC20)', 'ETHLend (LEND)', 'EXRNchain (EXRN)', 'EZToken (EZT)', 'EagleCoin (EAGLE)', 'Earth Token (EARTH)', 'Ebittree Coin (EBT)', 'EchoLink (EKO)', 'EcoCoin (ECO)', 'Ecobit (ECOB)', 'Edgeless (EDG)', 'EduCoin (EDU)', 'Education Ecosystem (LEDU)', 'Effect.AI (EFX)', 'EggCoin (EGG)', 'Eidoo (EDO)', 'Einsteinium (EMC2)', 'Elastic (XEL)', 'Elastos (ELA)', 'Elcoin (EL)', 'Electra (ECA)', 'Electrify.Asia (ELEC)', 'Electroneum (ETN)', 'Electronic PK Chain (EPC)', 'Elementrem (ELE)', 'Elite (1337)', 'Elixir (ELIX)', 'Ellaism (ELLA)', 'Elysium (ELS)', 'EmberCoin (EMB)', 'Embers (MBRS)', 'Emerald Crypto (EMD)', 'Emercoin (EMC)', 'Emphy (EPY)', 'EncrypGen (DNA)', 'EncryptoTel [ETH] (ETT)', 'EncryptoTel [WAVES] (ETT)', 'Endor Protocol (EDR)', 'Energo (TSL)', 'Energycoin (ENRG)', 'Engine (EGCC)', 'Enigma (ENG)', 'Enjin Coin (ENJ)', 'Envion (EVN)', 'Equal (EQL)', 'EquiTrader (EQT)', 'Ergo (EFYT)', 'Eroscoin (ERO)', 'Eryllium (ERY)', 'Escroco (ESC)', 'Espers (ESP)', 'Eternity (ENT)', 'EthBet (EBET)', 'Ethbits (ETBS)', 'Ether Zero (ETZ)', 'EtherDelta Token (EDT)', 'EtherSportz (ESZ)', 'Etherecash (ECH)', 'Ethereum (ETH)', 'Ethereum Cash (ECASH)', 'Ethereum Classic (ETC)', 'Ethereum Dark (ETHD)', 'Ethereum Gold (ETG)', 'Ethereum Lite (ELITE)', 'Ethereum Movie Venture (EMV)', 'Etheriya (RIYA)', 'Etheroll (DICE)', 'Etherparty (FUEL)', 'Ethorse (HORSE)', 'Ethos (ETHOS)', 'Eurocoin (EUC)', 'EuropeCoin (ERC)', 'EventChain (EVC)', 'EverGreenCoin (EGC)', 'Everex (EVX)', 'Everus (EVR)', 'Evil Coin (EVIL)', 'Exchange Union (XUC)', 'ExchangeN (EXN)', 'ExclusiveCoin (EXCL)', 'Eximchain (EXC)', 'Expanse (EXP)', 'Experience Points (XP)', 'Experty (EXY)', 'FAPcoin (FAP)', 'FLiK (FLIK)', 'FORCE (FOR)', 'FUNCoin (FUNC)', 'Fabric Token (FT)', 'Faceter (FACE)', 'Factom (FCT)', 'FairCoin (FAIR)', 'FairGame (FAIR)', 'Fantasy Cash (FANS)', 'Fantomcoin (FCN)', 'Farad (FRD)', 'Fargocoin (FRGC)', 'Farstcoin (FRCT)', 'Fastcoin (FST)', 'Fazzcoin (FAZZ)', 'Feathercoin (FTC)', 'FedoraCoin (TIPS)', 'Fidelium (FID)', 'FidentiaX (FDX)', 'Filecoin [Futures] (FIL)', 'FinCoin (FNC)', 'FintruX Network (FTX)', 'Firecoin (FIRE)', 'First Bitcoin (BIT)', 'First Bitcoin Capital (BITCF)', 'FirstBlood (1ST)', 'FirstCoin (FRST)', 'Fitrova (FRV)', 'Flash (FLASH)', 'Flaxscript (FLAX)', 'Flixxo (FLIXX)', 'FlorinCoin (FLO)', 'FlutterCoin (FLT)', 'Fluz Fluz (FLUZ)', 'FlypMe (FYP)', 'FoldingCoin (FLDC)', 'Fortuna (FOTA)', 'Francs (FRN)', 'Freicoin (FRC)', 'Freyrchain (FREC)', 'Friendz (FDZ)', 'FujiCoin (FJC)', 'Fujinto (NTO)', 'FunFair (FUN)', 'FundRequest (FND)', 'FundYourselfNow (FYN)', 'Fusion (FSN)', 'FuturXe (FXE)', 'FuturoCoin (FTO)', 'FuzeX (FXT)', 'FuzzBalls (FUZZ)', 'GBCGoldCoin (GBC)', 'GCN Coin (GCN)', 'GET Protocol (GET)', 'GINcoin (GIN)', 'GOLD Reward Token (GRX)', 'GXChain (GXS)', 'Galactrum (ORE)', 'Gambit (GAM)', 'Game.com (GTC)', 'GameChain System (GCS)', 'GameCredits (GAME)', 'GameUnits (UNITS)', 'Gapcoin (GAP)', 'Garlicoin (GRLC)', 'Gas (GAS)', 'Gatcoin (GAT)', 'GeertCoin (GEERT)', 'Gems  (GEM)', 'Genaro Network (GNX)', 'Genesis Vision (GVT)', 'GeoCoin (GEO)', 'GeyserCoin (GSR)', 'Gifto (GTO)', 'Gladius Token (GLA)', 'GlassCoin (GLS)', 'Global Cryptocurrency (GCC)', 'Global Currency Reserve (GCR)', 'Global Jobcoin (GJC)', 'Global Social Chain (GSC)', 'Global Tour Coin (GTC)', 'GlobalBoost-Y (BSTY)', 'GlobalCoin (GLC)', 'GlobalToken (GLT)', 'Gnosis (GNO)', 'GoByte (GBX)', 'Gold Pressed Latinum (GPL)', 'GoldBlocks (GB)', 'GoldCoin (GLD)', 'GoldMaxCoin (GMX)', 'GoldMint (MNTP)', 'GoldPieces (GP)', 'Golem (GNT)', 'Golfcoin (GOLF)', 'Golos (GOLOS)', 'Golos Gold (GBG)', 'Goodomy (GOOD)', 'Graft (GRFT)', 'GrandCoin (GDC)', 'Granite (GRN)', 'GreenMed (GRMD)', 'Grid+ (GRID)', 'GridCoin (GRC)', 'Grimcoin (GRIM)', 'Groestlcoin (GRS)', 'Growers International (GRWI)', 'Guaranteed Ethurance Token Extra (GETX)', 'GuccioneCoin (GCC)', 'Gulden (NLG)', 'Guncoin (GUN)', 'HEAT (HEAT)', 'HEROcoin (PLAY)', 'HODL Bucks (HDLB)', 'HOQU (HQX)', 'HOdlcoin (HODL)', 'HTMLCOIN (HTML)', 'Hacken (HKN)', 'Hackspace Capital (HAC)', 'HalalChain (HLC)', 'Halcyon (HAL)', 'Halloween Coin (HALLO)', 'Happycoin (HPC)', 'HarmonyCoin (HMC)', 'Harvest Masternode Coin (HC)', 'Hat.Exchange (HAT)', 'Haven Protocol (XHV)', 'Havven (HAV)', 'HealthyWormCoin (WORM)', 'Hedge (HDG)', 'Helbiz (HBZ)', 'Helleniccoin (HNC)', 'HelloGold (HGT)', 'HempCoin (THC)', 'Hero (HERO)', 'HeroNode (HER)', 'Hexx (HXX)', 'Hi Mutual Society (HMC)', 'HiCoin (XHI)', 'High Gain (HIGH)', 'High Performance Blockchain (HPB)', 'High Voltage (HVCO)', 'HireMatch (HIRE)', 'Hive Project (HVN)', 'HoboNickels (HBN)', 'HollyWoodCoin (HWC)', 'Holo (HOT)', 'HomeBlockCoin (HBC)', 'Honey (HONEY)', 'Hshare (HSR)', 'Hubii Network (HBT)', 'Humaniq (HMQ)', 'Huncoin (HNC)', 'HunterCoin (HUC)', 'Huobi Token (HT)', 'Hurify (HUR)', 'Hush (HUSH)', 'Hydro Protocol (HOT)', 'Hydrogen (HYDRO)', 'Hyper (HYPER)', 'Hyper Pay (HPY)', 'HyperStake (HYP)', 'I/O Coin (IOC)', 'I0Coin (I0C)', 'ICO OpenLedger (ICOO)', 'ICOBID (ICOB)', 'ICON (ICX)', 'ICOS (ICOS)', 'IDEX Membership (IDXM)', 'IHT Real Estate Protocol (IHT)', 'INS Ecosystem (INS)', 'ION (ION)', 'IOST (IOST)', 'IOTA (MIOTA)', 'IP Exchange (IPSX)', 'IPChain (IPC)', 'Iconic (ICON)', 'Iconomi (ICN)', 'Ignis (IGNIS)', 'Ignition (IC)', 'Impact (IMX)', 'ImpulseCoin (IMPS)', 'InPay (INPAY)', 'IncaKoin (NKA)', 'Incent (INCNT)', 'Independent Money System (IMS)', 'India Coin (INDIA)', 'Indicoin (INDI)', 'Indorse Token (IND)', 'Infinitecoin (IFC)', 'Infinity Economics (XIN)', 'InflationCoin (IFLT)', 'Influence Chain (INC)', 'Influxcoin (INFX)', 'Ink (INK)', 'Ink Protocol (XNK)', 'Innova (INN)', 'InsaneCoin (INSN)', 'Insights Network (INSTAR)', 'InsurChain (INSUR)', 'InsurePal (IPL)', 'Intelligent Investment Chain (IIC)', 'Intelligent Trading Foundation (ITT)', 'IntenseCoin (ITNS)', 'Internet Node Token (INT)', 'Internet of People (IOP)', 'Internet of Things (XOT)', 'Internxt (INXT)', 'Interstellar Holdings (HOLD)', 'Interzone (ITZ)', 'Invacio (INV)', 'InvestDigital (IDT)', 'InvestFeed (IFT)', 'IoT Chain (ITC)', 'IoTeX (IOTX)', 'IrishCoin (IRL)', 'IslaCoin (ISL)', 'Iungo (ING)', 'Ivy (IVY)', 'Ixcoin (IXC)', 'JET8 (J8T)', 'JavaScript Token (JS)', 'Jesus Coin (JC)', 'Jetcoin (JET)', 'Jewels (JWL)', 'Jibrel Network (JNT)', 'Jin Coin (JIN)', 'Jingtum Tech (SWTC)', 'Jiyo (JIYO)', 'JobsCoin (JOBS)', 'Joincoin (J)', 'Joulecoin (XJO)', 'KEY (KEY)', 'Karbo (KRB)', 'Karma (KRM)', 'KashhCoin (KASHH)', 'Kcash (KCASH)', 'KekCoin (KEK)', 'KickCoin (KICK)', 'KiloCoin (KLC)', 'Kin (KIN)', 'KingN Coin (KNC)', 'KlondikeCoin (KDC)', 'Kobocoin (KOBO)', 'Kolion (KLN)', 'Komodo (KMD)', 'Kore (KORE)', 'Kronecoin (KRONE)', 'KuCoin Shares (KCS)', 'Kubera Coin (KBR)', 'Kurrent (KURT)', 'KushCoin (KUSH)', 'Kyber Network (KNC)', 'LALA World (LALA)', 'LATOKEN (LA)', 'LBRY Credits (LBC)', 'LEOcoin (LEO)', 'LIFE (LIFE)', 'LOCIcoin (LOCI)', 'LUXCoin (LUX)', 'Lamden (TAU)', 'Lampix (PIX)', 'LanaCoin (LANA)', 'LandCoin (LDCN)', 'LatiumX (LATX)', 'LePen (LEPEN)', 'LeaCoin (LEA)', 'Leadcoin (LDC)', 'Legends Room (LGD)', 'Legolas Exchange (LGO)', 'Lendingblock (LND)', 'Lendroid Support Token (LST)', 'LetItRide (LIR)', 'Level Up Coin (LUC)', 'Leverj (LEV)', 'Leviar (XLC)', 'LevoPlus (LVPS)', 'Levocoin (LEVO)', 'Libra Credit (LBA)', 'LightChain (LIGHT)', 'Lightning Bitcoin (LBTC)', 'Linda (LINDA)', 'LinkEye (LET)', 'LinkedCoin (LKC)', 'Linker Coin (LNC)', 'Linx (LINX)', 'Lisk (LSK)', 'LiteBar (LTB)', 'LiteBitcoin (LBTC)', 'LiteCoin Ultra (LTCU)', 'LiteDoge (LDOGE)', 'Litecoin (LTC)', 'Litecoin Cash (LCC)', 'Litecoin Plus (LCP)', 'Litecred (LTCR)', 'Live Stars (LIVE)', 'LoMoCoin (LMC)', 'Local World Forwarders (LWF)', 'LockTrip (LOC)', 'Loki (LOKI)', 'Loom Network (LOOM)', 'Loopring (LRC)', 'Loopring [NEO] (LRN)', 'LoyalCoin (LYL)', 'LuckChain (BASH)', 'Luna Coin (LUNA)', 'Lunyr (LUN)', 'Lykke (LKK)', 'Lympo (LYM)', 'MACRON (MCRN)', 'MARK.SPACE (MRK)', 'MAZA (MZC)', 'MCAP (MCAP)', 'MEDX (MEDX)', 'MIRQ (MRQ)', 'MOAC (MOAC)', 'MSD (MSD)', 'MUSE (MUSE)', 'Machinecoin (MAC)', 'Madcoin (MDC)', 'Maecenas (ART)', 'Maggie (MAG)', 'Magi (XMG)', 'MagicCoin (MAGE)', 'Magnet (MAG)', 'Magnetcoin (MAGN)', 'Magnum (MGM)', 'MaidSafeCoin (MAID)', 'Maker (MKR)', 'Manna (MANNA)', 'Mao Zedong (MAO)', 'Marijuanacoin (MAR)', 'Marscoin (MARS)', 'MarteXcoin (MXT)', 'MarxCoin (MARX)', 'Masari (MSR)', 'Master Swiscoin (MSCN)', 'Masternodecoin (MTNC)', 'Matchpool (GUP)', 'Matrix AI Network (MAN)', 'Matryx (MTX)', 'Maverick Chain (MVC)', 'MaxCoin (MAX)', 'Measurable Data Token (MDT)', 'MediBloc (MED)', 'MediShares (MDS)', 'MedicCoin (MEDIC)', 'Medicalchain (MTN)', 'Megacoin (MEC)', 'Melon (MLN)', 'Memetic / PepeCoin (MEME)', 'Mercury (MER)', 'Mercury Protocol (GMT)', 'Metal (MTL)', 'Metal Music Coin (MTLMC3)', 'MetalCoin (METAL)', 'Metaverse ETP (ETP)', 'MicroMoney (AMM)', 'MiloCoin (MILO)', 'Mincoin (MNC)', 'MindCoin (MND)', 'Minereum (MNE)', 'Miners Reward Token (MRT)', 'Mineum (MNM)', 'Minex (MINEX)', 'MinexCoin (MNX)', 'Mintcoin (MINT)', 'Mithril (MITH)', 'Mixin (XIN)', 'MktCoin (MLM)', 'MobileGo (MGO)', 'Mobius (MOBI)', 'Modum (MOD)', 'Moeda Loyalty Points (MDA)', 'Moin (MOIN)', 'MojoCoin (MOJO)', 'Molecular Future (MOF)', 'MonaCoin (MONA)', 'Monaco (MCO)', 'Monero (XMR)', 'Monero Classic (XMC)', 'Monero Original (XMO)', 'MonetaryUnit (MUE)', 'Monetha (MTH)', 'Money ($$$)', 'Monkey Project (MONK)', 'Monoeci (XMCC)', 'Monster Byte (MBI)', 'Mooncoin (MOON)', 'Morpheus Labs (MITX)', 'Morpheus Network (MORPH)', 'Mothership (MSP)', 'Motocoin (MOTO)', 'Musicoin (MUSIC)', 'Musiconomi (MCI)', 'MustangCoin (MST)', 'MyBit Token (MYB)', 'MyToken (MT)', 'MyWish (WISH)', 'Myriad (XMY)', 'Mysterium (MYST)', 'NAGA (NGC)', 'NANJCOIN (NANJ)', 'NEM (XEM)', 'NEO (NEO)', 'NEO GOLD (NEOG)', 'NEVERDIE (NDC)', 'NKN (NKN)', 'NPER (NPER)', 'NaPoleonX (NPX)', 'Namecoin (NMC)', 'NamoCoin (NAMO)', 'Nano (NANO)', 'NavCoin (NAV)', 'Naviaddress (NAVI)', 'Neblio (NEBL)', 'Nebula AI (NBAI)', 'Nebulas (NAS)', 'Nectar (NEC)', 'Nekonium (NUKO)', 'NeosCoin (NEOS)', 'NetCoin (NET)', 'Netko (NETKO)', 'Network Token (NTWK)', 'Neumark (NEU)', 'Neuro (NRO)', 'Neurotoken (NTK)', 'Neutron (NTRN)', 'NevaCoin (NEVA)', 'NewYorkCoin (NYC)', 'Newbium (NEWB)', 'Nework (NKC)', 'Nexium (NXC)', 'Nexo (NEXO)', 'Nexty (NTY)', 'Nexus (NXS)', 'Nimiq Exchange Token (NET)', 'Nitro (NOX)', 'NoLimitCoin (NLC2)', 'Noah Coin (NOAH)', 'NobleCoin (NOBL)', 'NodeCoin (NODC)', 'Novacoin (NVC)', 'NuBits (USNBT)', 'NuShares (NSR)', 'Nucleus Vision (NCASH)', 'Nullex (NLX)', 'Nuls (NULS)', 'Numeraire (NMR)', 'Numus (NMS)', 'NumusCash (NUMUS)', 'Nxt (NXT)', 'Nyancoin (NYAN)', 'OAX (OAX)', 'OBITS (OBITS)', 'ODEM (ODE)', 'OFCOIN (OF)', 'OKCash (OK)', 'OP Coin (OPC)', 'OST (OST)', 'Obsidian (ODN)', 'OceanChain (OC)', 'Oceanlab (OCL)', 'Octanox (OTX)', 'OctoCoin (888)', 'Octoin Coin (OCC)', 'Odyssey (OCN)', 'Olympus Labs (MOT)', 'Omicron (OMC)', 'OmiseGO (OMG)', 'Omni (OMNI)', 'OneRoot Network (RNT)', 'Onix (ONX)', 'Ontology (ONT)', 'Opal (OPAL)', 'Open Platform (OPEN)', 'Open Trading Network (OTN)', 'Operand (OP)', 'Opus (OPT)', 'OracleChain (OCT)', 'Orbitcoin (ORB)', 'Origami (ORI)', 'OriginTrail (TRAC)', 'Ormeus Coin (ORME)', 'Oxycoin (OXY)', 'Oyster (PRL)', 'Oyster Shell (SHL)', 'PACcoin ($PAC)', 'PCHAIN (PAI)', 'PHI Token (PHI)', 'PIECoin (PIE)', 'PIVX (PIVX)', 'PLNcoin (PLNC)', 'POA Network (POA)', 'POLY AI (AI)', 'PRCoin (PRC)', 'PRIZM (PZM)', 'PROUD Money (PROUD)', 'PX (PX)', 'Pabyosi Coin (Special) (PCS)', 'Pakcoin (PAK)', 'Pandacoin (PND)', 'Paragon (PRG)', 'ParallelCoin (DUO)', 'Pareto Network (PARETO)', 'ParkByte (PKB)', 'Parkgene (GENE)', 'Particl (PART)', 'Pascal Coin (PASC)', 'Pascal Lite (PASL)', 'Patientory (PTOY)', 'Patron (PAT)', 'PayCoin (XPY)', 'PayCon (CON)', 'PayPie (PPP)', 'Payfair (PFR)', 'Paymon (PMNT)', 'Paypex (PAYX)', 'Peculium (PCL)', 'PeepCoin (PCN)', 'Peercoin (PPC)', 'Peerguess (GUESS)', 'Peerplays (PPY)', 'Penta (PNT)', 'Pepe Cash (PEPECASH)', 'Pesetacoin (PTC)', 'PetroDollar (XPD)', 'Phantasma (SOUL)', 'Phantomx (PNX)', 'Philosopher Stones (PHS)', 'Phoenixcoin (PXC)', 'Phore (PHR)', 'Photon (PHO)', 'Piggycoin (PIGGY)', 'PikcioChain (PKC)', 'Pillar (PLR)', 'PinkCoin (PINK)', 'Pioneer Coin (PCOIN)', 'PiplCoin (PIPL)', 'Pirate Blocks (SKULL)', 'Pirl (PIRL)', 'Pixie Coin (PXC)', 'Plancoin (PLAN)', 'PlatinumBAR (XPTX)', 'PlayerCoin (PLACO)', 'Playkey (PKT)', 'PlexCoin (PLX)', 'PlusCoin (PLC)', 'Pluton (PLU)', 'Po.et (POE)', 'PoSToken (POS)', 'PoSW Coin (POSW)', 'PokeCoin (POKE)', 'Polcoin (PLC)', 'PolicyPal Network (PAL)', 'Polis (POLIS)', 'PolySwarm (NCT)', 'Polybius (PLBT)', 'Polymath (POLY)', 'PonziCoin (PONZI)', 'PopularCoin (POP)', 'Populous (PPT)', 'PosEx (PEX)', 'PostCoin (POST)', 'PotCoin (POT)', 'Power Ledger (POWR)', 'Powercoin (PWR)', 'Presearch (PRE)', 'President Johnson (GARY)', 'President Trump (PRES)', 'PressOne (PRS)', 'Primalbase Token (PBT)', 'Primas (PST)', 'Prime-XI (PXI)', 'Primecoin (XPM)', 'Primulon (PRIMU)', 'PrismChain (PRM)', 'Privatix (PRIX)', 'ProChain (PRA)', 'ProCurrency (PROC)', 'Profile Utility Token (PUT)', 'Project-X (NANOX)', 'Propy (PRO)', 'Protean (PRN)', 'Prototanium (PR)', 'Proxeus (XES)', 'Publica (PBL)', 'Pundi X (NPXS)', 'Pura (PURA)', 'Pure (PURE)', 'PureVidz (VIDZ)', 'PutinCoin (PUT)', 'Pylon Network (PYLNT)', 'QASH (QASH)', 'QLINK (QLC)', 'Qbao (QBT)', 'Qbic (QBIC)', 'Qora (QORA)', 'Qtum (QTUM)', 'Quantstamp (QSP)', 'Quantum (QAU)', 'Quantum Resistant Ledger (QRL)', 'Quark (QRK)', 'QuarkChain (QKC)', 'Quatloo (QTL)', 'QuazarCoin (QCN)', 'Qube (QUBE)', 'QubitCoin (Q2C)', 'Quebecoin (QBC)', 'QunQun (QUN)', 'Quotient (XQN)', 'Qvolta (QVT)', 'Qwark (QWARK)', 'RChain (RHOC)', 'REAL (REAL)', 'REBL (REBL)', 'RED (RED)', 'REPO (REPO)', 'RSGPcoin (RSGP)', 'RabbitCoin (RBBT)', 'Radium (RADS)', 'Raiden Network Token (RDN)', 'Ratecoin (XRA)', 'Ravencoin (RVN)', 'Rawcoin (XRC)', 'Rcoin (RCN)', 'Read (READ)', 'RealChain (RCT)', 'Red Pulse (RPX)', 'RedCoin (RED)', 'ReddCoin (RDD)', 'ReeCoin (REE)', 'RefToken (REF)', 'Refereum (RFR)', 'Regacoin (REGA)', 'Regalcoin (REC)', 'Remme (REM)', 'Renos (RNS)', 'Rentberry (BERRY)', 'Republic Protocol (REN)', 'Request Network (REQ)', 'Restart Energy MWAT (MWAT)', 'Revain (R)', 'RevolutionVR (RVR)', 'RevolverCoin (XRE)', 'Rhenium (XRH)', 'Rialto (XRL)', 'RichCoin (RICHX)', 'Riecoin (RIC)', 'Rimbit (RBT)', 'Ripio Credit Network (RCN)', 'Ripple (XRP)', 'Rise (RISE)', 'Rivetz (RVT)', 'Rock (RKT)', 'RonPaulCoin (RPC)', 'Roofs (ROOFS)', 'RouletteToken (RLT)', 'Royal Kingdom Coin (RKC)', 'Royalties (XRY)', 'Rubies (RBIES)', 'Rublix (RBLX)', 'Rubycoin (RBY)', 'Ruff (RUFF)', 'Runners (RUNNERS)', 'Rupaya (RUPX)', 'Rupee (RUP)', 'RussiaCoin (RC)', 'Russian Miner Coin (RMC)', 'SALT (SALT)', 'SHACoin (SHA)', 'SHIELD (XSH)', 'SIBCoin (SIB)', 'SIGMAcoin (SIGMA)', 'SIRIN LABS Token (SRN)', 'SISA (SISA)', 'SJWCoin (SJW)', 'SOILcoin (SOIL)', 'SONM (SNM)', 'SONO (SONO)', 'SPINDLE (SPD)', 'SRCOIN (SRCOIN)', 'STEX (STEX)', 'STK (STK)', 'STRAKS (STAK)', 'Safe Exchange Coin (SAFEX)', 'Safe Trade Coin (XSTC)', 'SagaCoin (SAGA)', 'Sakura Bloom (SKB)', 'Sakuracoin (SKR)', 'SalPay (SAL)', 'SaluS (SLS)', 'Santiment Network Token (SAN)', 'Sativacoin (STV)', 'SatoshiMadness (MAD)', 'Save and Gain (SANDG)', 'Scorecoin (SCORE)', 'Scry.info (DDD)', 'SecretCoin (SCRT)', 'SecureCoin (SRC)', 'Seele (SEELE)', 'SegWit2x (B2X)', 'SelfSell (SSC)', 'Selfkey (KEY)', 'Senderon (SDRN)', 'Sense (SENSE)', 'Sentinel (SENT)', 'Sentinel Chain (SENC)', 'Sequence (SEQ)', 'Sether (SETH)', 'Sexcoin (SXC)', 'Shadow Token (SHDW)', 'ShadowCash (SDC)', 'Sharder (SS)', 'ShareX (SEXC)', 'Sharechain (SSS)', 'Sharkcoin (SAK)', 'Sharpe Platform Token (SHP)', 'Shekel (JEW)', 'ShellCoin (SHELL)', 'Shift (SHIFT)', 'ShipChain (SHIP)', 'Shivom (OMX)', 'Shopin (SHOP)', 'Shorty (SHORTY)', 'Show (SHOW)', 'Siacoin (SC)', 'Signals Network (SGN)', 'Signatum (SIGT)', 'Silent Notary (SNTR)', 'SingularDTV (SNGLS)', 'SingularityNET (AGI)', 'SixEleven (611)', 'Skeincoin (SKC)', 'SkinCoin (SKIN)', 'Skrumble Network (SKM)', 'Skycoin (SKY)', 'Slevin (SLEVIN)', 'Slothcoin (SLOTH)', 'SmartCash (SMART)', 'SmartCoin (SMC)', 'SmartMesh (SMT)', 'Smartlands (SLT)', 'SmileyCoin (SMLY)', 'Smoke (SMOKE)', 'SnipCoin (SNIP)', 'Snovio (SNOV)', 'Soarcoin (SOAR)', 'Social Send (SEND)', 'SocialCoin (SOCC)', 'Sociall (SCL)', 'SolarCoin (SLR)', 'Solarflarecoin (SFC)', 'Solaris (XLR)', 'Soma (SCT)', 'SongCoin (SONG)', 'SoonCoin (SOON)', 'SophiaTX (SPHTX)', 'Sovereign Hero (HERO)', 'SpaceChain (SPC)', 'SpaceCoin (SPACE)', 'SpankChain (SPANK)', 'Sparks (SPK)', 'Spectiv (SIG)', 'Spectre.ai Dividend Token (SXDT)', 'Spectre.ai Utility Token (SXUT)', 'Spectrecoin (XSPEC)', 'Speed Mining Service (SMS)', 'SpeedCash (SCS)', 'Sphere (SPHR)', 'Sphre AIR  (XID)', 'SportsCoin (SPORT)', 'SportyCo (SPF)', 'SpreadCoin (SPR)', 'Sprouts (SPRTS)', 'Stakenet (XSN)', 'StarCash Network (STARS)', 'StarChain (STC)', 'StarCoin (KST)', 'StarCredits (STRC)', 'Starbase (STAR)', 'Starta (STA)', 'Startcoin (START)', 'StarterCoin (STAC)', 'Status (SNT)', 'Stealth (XST)', 'Steem (STEEM)', 'Steem Dollars (SBD)', 'Stellar (XLM)', 'Stellite (XTL)', 'Steneum Coin (STN)', 'Sterlingcoin (SLG)', 'Stipend (SPD)', 'StockChain (SCC)', 'Storiqa (STQ)', 'Storj (STORJ)', 'Storjcoin X (SJCX)', 'Storm (STORM)', 'Stox (STX)', 'Stratis (STRAT)', 'Streamr DATAcoin (DATA)', 'StrikeBitClub (SBC)', 'StrongHands (SHND)', 'Substratum (SUB)', 'Sugar Exchange (SGR)', 'Sumokoin (SUMO)', 'SunContract (SNC)', 'Super Bitcoin (SBTC)', 'Super Game Chain (SGCC)', 'SuperCoin (SUPER)', 'SuperNET (UNITY)', 'Superior Coin (SUP)', 'SureRemit (RMT)', 'Suretly (SUR)', 'Swarm (SWM)', 'Swarm City (SWT)', 'SwftCoin (SWFTC)', 'Swing (SWING)', 'SwissBorg (CHSB)', 'Swisscoin (SIC)', 'Switcheo (SWTH)', 'SyncFab (MFG)', 'Syndicate (SYNX)', 'Synereo (AMP)', 'Synergy (SNRG)', 'Syscoin (SYS)', 'T-coin (TCOIN)', 'TE-FOOD (TFD)', 'TEKcoin (TEK)', 'THEKEY (TKY)', 'TOKYO (TOKC)', 'TRAXIA (TMT)', 'TRON (TRX)', 'TaaS (TAAS)', 'TagCoin (TAG)', 'TajCoin (TAJ)', 'Tao (XTO)', 'Target Coin (TGT)', 'Tattoocoin (Limited Edition) (TLE)', 'Tattoocoin (Standard Edition) (TSE)', 'Telcoin (TEL)', 'Tellurion (TELL)', 'TenX (PAY)', 'TerraNova (TER)', 'Terracoin (TRC)', 'TeslaCoilCoin (TESLA)', 'TeslaCoin (TES)', 'Tether (USDT)', 'Tezos (Pre-Launch) (XTZ)', 'The Abyss (ABYSS)', 'The ChampCoin (TCC)', 'The Cypherfunks (FUNK)', 'Theresa May Coin (MAY)', 'Theta Token (THETA)', 'Tidex Token (TDX)', 'Tierion (TNT)', 'Ties.DB (TIE)', 'Tigercoin (TGC)', 'Tigereum (TIG)', 'Time New Bank (TNB)', 'Titcoin (TIT)', 'TittieCoin (TTC)', 'ToaCoin (TOA)', 'TodayCoin (TODAY)', 'TokenCard (TKN)', 'TokenClub (TCT)', 'TokenDesk (TDS)', 'TokenPay (TPAY)', 'TokenStars (TEAM)', 'Tokenbox (TBX)', 'Tokenomy (TEN)', 'Tokes (TKS)', 'Tokia (TKA)', 'Tokugawa (TOK)', 'TomoChain (TOMO)', 'TopChain (TOPC)', 'TopCoin (TOP)', 'TraDove B2BCoin (BBC)', 'Tracto (TRCT)', 'Trade Token (TIO)', 'TrakInvest (TRAK)', 'Transcodium (TNS)', 'TransferCoin (TX)', 'Travala (AVA)', 'Travelflex (TRF)', 'TrezarCoin (TZC)', 'Triangles (TRI)', 'Trident Group (TRDT)', 'Triggers (TRIG)', 'Trinity Network Credit (TNC)', 'Tripio (TRIO)', 'Tristar Coin (TSTR)', 'Trollcoin (TROLL)', 'Truckcoin (TRK)', 'True Chain (TRUE)', 'TrueFlip (TFL)', 'TrueUSD (TUSD)', 'TrumpCoin (TRUMP)', 'TrustNote (TTT)', 'TrustPlus (TRUST)', 'TurboCoin (TURBO)', 'U Network (UUU)', 'U.CASH (UCASH)', 'UGAIN (GAIN)', 'UNCoin (UNC)', 'UR (UR)', 'UTRUST (UTK)', 'Ubiq (UBQ)', 'Ulatech (ULA)', 'Ultimate Secure Cash (USC)', 'UltraCoin (UTC)', 'UnbreakableCoin (UNB)', 'UniCoin (UNIC)', 'Unibright (UBT)', 'Uniform Fiscal Object (UFO)', 'Unify (UNIFY)', 'Unikoin Gold (UKG)', 'United Bitcoin (UBTC)', 'United Crypto Community (UCOM)', 'United Traders Token (UTT)', 'Unitus (UIS)', 'Universa (UTNP)', 'Universal Currency (UNIT)', 'UniversalRoyalCoin (UNRC)', 'Universe (UNI)', 'UnlimitedIP (UIP)', 'Unobtanium (UNO)', 'UpToken (UP)', 'Upfiring (UFR)', 'Uquid Coin (UQC)', 'Useless Ethereum Token (UET)', 'Utrum (OOT)', 'VIBE (VIBE)', 'VIVO (VIVO)', 'ValueChain (VLC)', 'VapersCoin (VPRC)', 'Vault Coin (VLTC)', 'Vcash (XVC)', 'VeChain (VEN)', 'VectorAI (VEC2)', 'Veltor (VLT)', 'Verge (XVG)', 'VeriCoin (VRC)', 'VeriME (VME)', 'Verify (CRED)', 'Veritaseum (VERI)', 'VeriumReserve (VRM)', 'Veros (VRS)', 'Version (V)', 'Vertcoin (VTC)', 'Vezt (VZT)', 'Viacoin (VIA)', 'Viberate (VIB)', 'Vice Industry Token (VIT)', 'Vipstar Coin (VIPS)', 'Virta Unique Coin (VUC)', 'Virtacoin (VTA)', 'Visio (VISIO)', 'Viuly (VIU)', 'Voise (VOISE)', 'VoteCoin (VOT)', 'Vsync (VSX)', 'Vulcano (VULC)', 'W3Coin (W3C)', 'WA Space (WA)', 'WAX (WAX)', 'WCOIN (WIN)', 'WETH (WETH)', 'WINCOIN (WC)', 'WaBi (WABI)', 'Wagerr (WGR)', 'Waltonchain (WTC)', 'Wanchain (WAN)', 'WandX (WAND)', 'Waves (WAVES)', 'Waves Community Token (WCT)', 'WavesGo (WGO)', 'WaykiChain (WICC)', 'WeAreSatoshi (WSX)', 'WePower (WPR)', 'WeTrust (TRST)', 'WhaleCoin (WHL)', 'WhiteCoin (XWC)', 'Wi Coin (WIC)', 'Wild Beast Block (WBB)', 'Wild Crypto (WILD)', 'Wings (WINGS)', 'Wink (WINK)', 'WomenCoin (WOMEN)', 'Woodcoin (LOG)', 'WorldCoin (WDC)', 'Worldcore (WRC)', 'X-Coin (XCO)', 'X2 (X2)', 'XGOX (XGOX)', 'XPA (XPA)', 'XTD Coin (XTD)', 'XTRABYTES (XBY)', 'XYO Network (XYO)', 'Xaurum (XAUR)', 'Xenon (XNN)', 'XinFin Network (XDCE)', 'YEE (YEE)', 'YENTEN (YTN)', 'YOYOW (YOYOW)', 'Yocoin (YOC)', 'ZClassic (ZCL)', 'ZCoin (XZC)', 'ZIP (ZIP)', 'ZSEcoin (ZSE)', 'Zap (ZAP)', 'Zayedcoin (ZYD)', 'Zcash (ZEC)', 'Zebi (ZCO)', 'Zeepin (ZPT)', 'Zeitcoin (ZEIT)', 'ZenCash (ZEN)', 'ZenGold (ZENGOLD)', 'Zennies (ZENI)', 'Zephyr (ZEPH)', 'Zero (ZER)', 'ZetaMicron (ZMC)', 'Zetacoin (ZET)', 'Zeusshield (ZSC)', 'Zilbercoin (ZBC)', 'Zilla (ZLA)', 'Zilliqa (ZIL)', 'Zippie (ZIPT)', 'ZoZoCoin (ZZC)', 'Zoin (ZOI)', 'ZrCoin (ZRC)', 'Zurcoin (ZUR)', 'aXpire (AXP)', 'adToken (ADT)', 'adbank (ADB)', 'aelf (ELF)', 'bitBTC (BITBTC)', 'bitCNY (BITCNY)', 'bitEUR (BITEUR)', 'bitGold (BITGOLD)', 'bitJob (STU)', 'bitSilver (BITSILVER)', 'bitUSD (BITUSD)', 'bitqy (BQ)', 'carVertical (CV)', 'district0x (DNT)', 'e-Gulden (EFL)', 'eBitcoin (EBTC)', 'eBoost (EBST)', 'eREAL (EREAL)', 'eosDAC (EOSDAC)', 'iBank (IBANK)', 'iCoin (ICN)', 'iEthereum (IETH)', 'iExec RLC (RLC)', 'iQuant (IQT)', 'iTicoin (ITI)', 'iXledger (IXT)', 'imbrex (REX)', 'indaHash (IDH)', 'onG.social (ONG)', 'ugChain (UGC)', 'vSlice (VSL)', 'vTorrent (VTR)']

coins = ['1896', '2837', '2601', '1252', '1840', '93', '1322', '890', '2722', '2515', '2357', '2407', '2040', '2199', '2607', '2767', '2721', '1688', '938', '1970', '2136', '2015', '1910', '2380', '2393', '2171', '2225', '2311', '1351', '1918', '601', '2438', '1915', '1768', '2646', '1883', '2660', '911', '1434', '1136', '1026', '2193', '2153', '1700', '1949', '2462', '1706', '2367', '2062', '2058', '2037', '2054', '2473', '1439', '1554', '1256', '2525', '1642', '2081', '1716', '2705', '1035', '994', '2517', '150', '43', '1753', '2641', '2684', '2344', '1247', '1680', '2639', '2415', '2545', '1320', '31', '1558', '142', '1586', '374', '1361', '1609', '1848', '269', '1176', '2732', '2190', '1624', '1420', '2653', '948', '1104', '2423', '148', '666', '2051', '2151', '1146', '1948', '1533', '1020', '2204', '1371', '2572', '1223', '2223', '1534', '2095', '1926', '2114', '2119', '295', '2592', '1727', '2743', '1597', '2842', '2390', '2598', '1697', '2046', '945', '819', '1397', '2557', '217', '2636', '1509', '1604', '70', '2703', '2727', '2551', '1916', '2307', '2324', '1198', '2836', '1981', '1839', '1579', '2521', '2690', '1442', '1849', '2009', '1818', '1885', '14', '723', '2334', '1824', '1513', '2374', '1990', '356', '2612', '366', '2194', '463', '2059', '2619', '1359', '2561', '2489', '2285', '2129', '1381', '1', '1248', '2387', '1831', '2222', '747', '2370', '2083', '2604', '2702', '1748', '293', '2575', '2093', '205', '467', '2281', '2041', '1654', '1063', '1457', '1793', '34', '543', '1741', '1754', '276', '2648', '659', '1657', '842', '990', '170', '1976', '125', '415', '1623', '2614', '2445', '1882', '2247', '2061', '2747', '1374', '2615', '707', '2167', '2465', '1873', '2340', '1864', '2076', '290', '2505', '2605', '1773', '2211', '1897', '1053', '2256', '406', '350', '2392', '2310', '2717', '1965', '993', '2657', '2306', '1286', '1303', '1763', '2033', '426', '918', '2654', '49', '2260', '1206', '594', '573', '1962', '1492', '734', '372', '1866', '1193', '2856', '2356', '2851', '1986', '2596', '2262', '2266', '2543', '2049', '1989', '2482', '2444', '1810', '1210', '134', '898', '2757', '1842', '2343', '304', '2485', '279', '506', '1674', '2248', '1008', '2152', '502', '2010', '2490', '2855', '2529', '159', '45', '84', '2770', '2241', '2585', '1546', '999', '1975', '2673', '1760', '2060', '2427', '1728', '1297', '1556', '1985', '2043', '788', '1816', '460', '2622', '2089', '362', '2385', '1135', '2006', '317', '1729', '1837', '2045', 'O ', '367', '2478', '2470', '2569', '2352', '1630', '1889', '2001', '2753', '1291', '2650', '2372', '998', '1632', '1662', '2715', '2621', '2735', '2358', '2834', '2638', '2858', '132', '1738', '2342', '869', '1850', '1469', '1676', '2150', '1153', '2556', '1963', '986', '2671', '2708', '2268', '720', '2664', '337', '2766', '2447', '933', '1510', '1987', '1777', '1544', '1306', '2027', '501', '2314', '2353', '2032', '2559', '1435', '333', '2652', '2246', '2642', '2719', '992', '1945', '2535', '2696', '1771', '2726', '1310', '2446', '2567', '2508', '1478', '2304', '2312', '2503', '1964', '2308', '1912', '2656', '1503', '1614', '2746', '131', '660', '1603', '69', '2752', '2510', '2283', '1797', '1288', '2584', '2175', '1966', '2679', '2176', '1168', '2316', '1881', '2162', '1769', '1886', '1876', '2665', '2148', '1180', '2528', '1640', '72', '2464', '2649', '77', '109', '1100', '2207', '1687', '1520', '1884', '405', '654', '18', '2772', '2739', '1229', '2659', '90', '1745', '2229', '1501', '2711', '2675', '74', '1485', '1395', '2070', '385', '145', '814', '2110', '1120', '2593', '2243', '316', '2591', '1611', '2067', '1587', '2298', '1436', '1358', '1618', '2183', '2187', '212', '1216', '2453', '2831', '2147', '2331', '1765', '1851', '2165', '2239', '2088', '2560', '2182', '2668', '1634', '2391', '1685', '1782', '1596', '2734', '2562', '2666', '912', '2057', '201', '1737', '2492', '1249', '1711', '2573', '2137', '2487', '1334', '1109', '1980', '2122', '1539', '1843', '1815', '50', '558', '2172', '2208', '2018', '1714', '2835', '2215', '322', '2852', '2044', '2130', '2526', '2479', '1686', '1762', '2249', '1535', '2338', '1238', '1474', '2026', '1699', '2843', '2409', '2509', '2532', '1027', '2048', '1321', '1973', '2074', '2101', '1625', '1890', '1677', '2120', '2413', '1817', '1038', '964', '2237', '1148', '2034', '2066', '1165', '2091', '2055', '633', '2778', '1070', '1367', '2547', '2118', '2025', '2142', '1670', '2768', '2775', '1087', '224', '2366', '1234', '370', '2159', '1497', '2322', '32', '1635', '8', '87', '2637', '2333', '2280', '1800', '2667', '476', '1323', '1871', '1403', '1522', '2730', '1755', '1010', '2231', '64', '218', '2587', '2126', '606', '2472', '1164', '10', '2733', '2626', '960', '1938', '1757', '2751', '1857', '2530', '1798', '2846', '2723', '1241', '1128', '730', '2354', '2773', '2192', '1750', '2411', '939', '2336', '2350', '576', '1502', '708', '2475', '1785', '2425', '1570', '2537', '2291', '2181', '823', '1846', '2289', '2534', '2232', '1531', '1044', '2401', '2737', '1801', '644', '51', '1731', '1659', '2200', '1665', '1285', '25', '1213', '2513', '785', '1455', '1375', '1480', '1542', '1752', '2571', '71', '382', '2651', '2134', '833', '2168', '258', '1900', '2589', '1033', '254', '312', '1308', '2323', '2004', '2564', '1195', '2315', '2360', '2397', '2480', '545', '1679', '1628', '1832', '2412', '2179', '2662', '2586', '1602', '2079', '2680', '1004', '2042', '416', '2755', '2754', '977', '2484', '1244', '2138', '2345', '1282', '2590', '1950', '78', '2278', '2682', '2317', '1581', '1903', '2031', '1669', '1742', '130', '2502', '2849', '1466', '2430', '2698', '353', '2329', '525', '495', '63', '1276', '1514', '2099', '2082', '2422', '2552', '2369', '1281', '2405', '1720', '2617', '2433', '1528', '1408', '2276', '2395', '1607', '1438', '1626', '797', '1475', '1194', '1997', '2519', '1967', '41', '2013', '1504', '2740', '1069', '2209', '2549', '2160', '1678', '2558', '2736', '2421', '2741', '2103', '2185', '2399', '1464', '1631', '2022', '2173', '1994', '2774', '2406', '1888', '2251', '2777', '988', '1084', '2504', '2833', '13', '2568', '2100', '2520', '1787', '1379', '2498', '1390', '2383', '2253', '1421', '536', '68', '2713', '1340', '2378', '1551', '2379', '1852', '2017', '1182', '1993', '1743', '101', '815', '1999', '1521', '400', '1943', '2087', '2263', '1468', '1529', '1982', '2582', '2090', '1298', '1022', '2078', '2518', '2107', '2337', '1988', '1257', '1507', '2594', '1530', '892', '2580', '1722', '2600', '2686', '2609', '1309', '2779', '2377', '1746', '1568', '1429', '2760', '2435', '2335', '1814', '2468', '1313', '2677', '1724', '1214', '174', '1825', '1935', '853', '2', '2540', '331', '1155', '2710', '1380', '2761', '2287', '2748', '2588', '1934', '2693', '2841', '1463', '1496', '1658', '1454', '2554', '1644', '2669', '164', '1690', '2845', '2853', '2403', '2008', '920', '812', '2326', '2064', '2434', '629', '2250', '2218', '1952', '1523', '291', '1518', '1019', '1869', '1548', '154', '1266', '1565', '2674', '1550', '1946', '1616', '2474', '2325', '2418', '128', '2348', '2303', '2274', '916', '2497', '37', '1552', '1191', '1590', '2098', '1788', '983', '796', '1703', '2286', '1576', '9', '1139', '1673', '1739', '1283', '1863', '2139', '141', '2608', '2349', '2516', '1715', '2429', '2080', '1954', '1141', '1212', '2441', '213', '1776', '328', '2655', '2632', '706', '1947', '1110', '2230', '1922', '1887', '89', '2709', '2763', '1847', '360', '1577', '2000', '1396', '1902', '2712', '2236', '182', '1721', '2305', '2595', '873', '1376', '2174', '1872', '2780', '2744', '2602', '3', '1920', '1567', '377', '2825', '1955', '2692', '1908', '2538', '2257', '551', '75', '1582', '2109', '2318', '1717', '2536', '894', '1200', '298', '1275', '2477', '1481', '2694', '2714', '789', '1811', '2420', '1382', '2599', '117', '1479', '6', '626', '699', '2544', '1268', '2092', '1732', '2351', '2347', '66', '120', '1853', '1123', '2631', '2456', '760', '2355', '2296', '2005', '2483', '1959', '1733', '221', '2583', '2458', '2327', '1400', '1808', '83', '2400', '1747', '2566', '597', '2762', '2069', '1222', '1931', '1838', '80', '2681', '2467', '1998', '2170', '2202', '2750', '1107', '2838', '2676', '1563', '1169', '263', '2548', '2224', '1555', '1681', '1398', '1357', 'Special ', '1066', '161', '2094', '1089', '2495', '934', '2720', '1826', '1473', '1575', '1708', '2759', '764', '818', '2036', '2244', '2848', '2191', '2610', '1803', '5', '2461', '1719', '2691', '1405', '151', '260', '2827', '2205', '76', '35', '2158', '175', '386', '2854', '1834', '313', '2265', '2056', '1756', '2105', '2670', '2706', '1254', '2115', '2279', '2228', '2186', '1392', '1937', '2038', '1495', '1330', '257', '2718', '2359', '2630', '1784', '2496', '1259', '275', '1789', '1209', '1218', '122', '2132', '1279', '2245', '1352', '1348', '2455', '1841', '1930', '656', '42', '1827', '1271', '2184', '2275', '1650', '2419', '1691', '1974', '1913', '1093', '2687', '2217', '2603', '870', '2146', '1511', '1299', '2330', '2213', '2321', '2242', '2460', '344', '1684', '2212', '1709', '1712', '53', '2840', '461', '338', '2408', '129', '278', '2375', '733', '2124', '1226', '2021', '2030', '2368', '2771', '2829', '1822', '572', '1154', '2161', '978', '2577', '1472', '1418', '2440', '2414', '2112', '103', '118', '1307', '2436', '2553', '1459', '2007', '2546', '1559', '2628', '2539', '2071', '2533', '2135', '1208', '1284', '2769', '1812', '1269', '160', '703', '2096', '52', '1294', '1991', '2550', '88', '2117', '1683', '2053', '1835', '1175', '2689', '215', '2476', '2077', '1877', '1799', '1147', '2125', '1996', '411', '2144', '1082', '1921', '2313', '2189', '1028', '1111', '1723', '2140', '2828', '2672', '1707', '2493', '2332', '1172', '1506', '2261', '2742', '1425', '2857', '1159', '1807', '680', '1048', '1090', '1610', '2428', '1113', '57', '2830', '2072', '2439', '2398', '2039', '2402', '2643', '2624', '1399', '2555', '58', '1878', '493', '2699', '2426', '2177', '841', '2581', '2514', '924', '1050', '2579', '2844', '2839', '1482', '2361', '1042', '2749', '1836', '2764', '1409', '2424', '1251', '199', '1830', '2725', '1619', '1781', '287', '1828', '113', '2277', '2471', '799', '1898', '2647', '2258', '1595', '2255', '1774', '1969', '233', '1525', '1606', '2272', '857', '795', '2309', '1805', '2410', '1058', '2219', '2448', '2611', '2381', '2382', '1505', '2486', '1651', '914', '1795', '1385', '2270', '702', '1002', '2633', '2157', '2432', '2663', '1942', '2295', '1819', '389', '2565', '1759', '448', '1230', '1312', '512', '2629', '2362', '627', '2616', '2618', '2541', '1772', '549', '2297', '1861', '1343', '2143', '2259', '1106', '1984', '2196', '1694', '1786', '2282', '2738', '341', '643', '2522', '2527', '1933', '2506', '1562', '2341', '1085', '2499', '2050', '2620', '2658', '1304', '1125', '951', '541', '1489', '2578', '325', '2507', '2404', '2850', '1958', '1592', '61', '1353', '1391', '1995', 'Limited Edition ', 'Standard Edition ', '2394', '1393', '1758', '1809', '4', '1264', '114', '825', 'Pre-Launch ', '2847', '1894', '965', '1693', '2416', '2542', '1923', '2166', '79', '2523', '2235', '513', '719', '1833', '1356', '1660', '2364', '2635', '2627', '2729', '2452', '2576', '1588', '2756', '2264', '2570', '2376', '135', '2678', '2063', '2373', '2683', '2704', '1032', '2776', '2491', '2002', '477', '2284', '1423', '2443', '2661', '1608', '638', '468', '2457', '1905', '2563', '1185', '2701', '450', '1767', '2645', '2512', '1336', '855', '1561', '2320', '588', '1927', '1617', '121', '334', '959', '2758', '168', '1736', '2149', '2293', '2386', '2371', '781', '2524', '921', '1783', '1605', '2454', '67', '2597', '2178', '2273', '1778', '2731', '1983', '1956', '2488', '1341', '1486', '836', '1904', '1052', '1368', '693', '323', '2695', '2271', '1710', '1387', '1465', '1702', '99', '2384', '470', '2019', '2625', '2688', '1792', '520', '1566', '2198', '2012', '2221', '1951', '2123', '2531', '1449', '2300', '2640', '2396', '2201', '2267', '1779', '1925', '2606', '2269', '1274', '1527', '1643', '2346', '584', '2511', '1638', '2024', '268', '1979', '831', '2029', '1500', '1865', '1790', '859', '16', '2288', '837', '1131', '2065', '1968', '1907', '1636', '2765', '895', '2106', '2634', '2437', '2290', '1899', '1156', '1447', '1414', '2826', '1598', '2363', '1389', '1437', '2685', '2481', '181', '1698', '1695', '1629', '2163', '1578', '1456', '56', '2047', '1526', '2500', '2469', '2724', '2214', '1448', '1726', '1250', '2466', '1775', '2501', '2299', '625', '624', '954', '778', '2180', '813', '623', '1917', '2450', '1856', '234', '2127', '1704', '2108', '2644', '1515', '138', '2104', '1637', '1971', '1671', '1845', '1961', '2459', '2240', '2389', '1483', '766']
cur_type = ["USD","AUD","BRL","CAD","CHF","CLP","CNY","CZK","DKK","EUR","GBP","HKD","HUF","IDR","ILS","INR","JPY","KRW","MXN","MYR","NOK","NZD","PHP","PKR","PLN","RUB","SEK","SGD","THB","TRY","TWD","ZAR","BTC","ETH","XRP","LTC","BCH"]


if not os.path.exists(profileDir):
    os.makedirs(profileDir)

dbFile = os.path.join(profileDir, 'watching.db')  
dbcon=database.connect(dbFile)
dbcur=dbcon.cursor()

try:
    dbcur.execute("CREATE TABLE IF NOT EXISTS alerts (id INT, updates REAL);")
except:
    pass

dbcon.close()

def get(path, args={}):
    r = requests.get(path, data=args, headers = {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36'}, verify=False)
    return r.text

if __name__ == '__main__':
    monitor = xbmc.Monitor()
    
    while not monitor.abortRequested():
        if monitor.waitForAbort(int(xbmcaddon.Addon().getSetting('timer'))*60):
            # Abort was requested while waiting. We should exit
            break
        
        try:
            dbcon=database.connect(dbFile)
            dbcur=dbcon.cursor()

            dbcur.execute("DELETE FROM alerts WHERE updates < "+str(time.time()))
            dbcon.commit()

            for i in range(1, 5):
                if addon.getSetting('active'+str(i)) == "true":
                    dbcur.execute("SELECT * FROM alerts WHERE id = "+str(i))
                    r=dbcur.fetchall()

                    if not r:
                        ids = coins[int(xbmcaddon.Addon().getSetting('crypt'+str(i)))]
                        default_currency = cur_type[int(xbmcaddon.Addon().getSetting('default_currency'))]
                        cmc = json.loads(get("https://api.coinmarketcap.com/v2/ticker/"+str(ids)+"?convert="+default_currency).decode('utf-8'), parse_float=str)
                        price = cmc['data']['quotes'][default_currency]['price']

                        xbmc.log(xbmcaddon.Addon().getSetting('cond'+str(i))+" and "+str(price)+" >= "+str(xbmcaddon.Addon().getSetting('value'+str(i))), level=xbmc.LOGNOTICE)

                        if xbmcaddon.Addon().getSetting('cond'+str(i)) == "0" and float(price) >= float(xbmcaddon.Addon().getSetting('value'+str(i))):
                            xbmc.executebuiltin('Notification(%s, %s, %d, %s)' % (addon.getAddonInfo('name'), names[int(xbmcaddon.Addon().getSetting('crypt'+str(i)))] + " is higher than " + xbmcaddon.Addon().getSetting('value'+str(i)) + " " +default_currency, 5000, addon.getAddonInfo('icon')))

                            dbcur.execute("INSERT INTO alerts (id, updates) VALUES ('"+str(i)+"', '"+str(time.time()+(int(xbmcaddon.Addon().getSetting('timer_delay'))*3600))+"')")
                            dbcon.commit()
                        elif xbmcaddon.Addon().getSetting('cond'+str(i)) == "1" and float(price) < float(xbmcaddon.Addon().getSetting('value'+str(i))):
                            xbmc.executebuiltin('Notification(%s, %s, %d, %s)' % (addon.getAddonInfo('name'), names[int(xbmcaddon.Addon().getSetting('crypt'+str(i)))] + " is lower than " + xbmcaddon.Addon().getSetting('value'+str(i)) + " " +default_currency, 5000, addon.getAddonInfo('icon')))

                            dbcur.execute("INSERT INTO alerts (id, updates) VALUES ('"+str(i)+"', '"+str(time.time()+(int(xbmcaddon.Addon().getSetting('timer_delay'))*3600))+"')")
                            dbcon.commit()

            dbcon.close()
        except Exception as e:
            # something went wrong
            xbmc.log(str(e), xbmc.LOGERROR)
            
                    
